/*
 * Part of the solution for Assignment 3 (CSC 218, Winter 2003), by
 * Stefan Bruda.
 */
#ifndef __STREE_H
#define __STREE_H

#include <string.h>
#include "btree.h"

class stree: public btree {
    /* 
     * Helper functions, from the previous assignment (now private).
     * There are some minor changes, see stree.cc.
     */
    node* memtree(char*, node*) const;
    node* instree(char*, node*) const;  
    node* delnode(node*, node*) const;
    
 public:
    /*
     * Default constructors, assignment operator, and destructor are
     * fine (since they call their counterparts in btree).  So we do not
     * have to define any of them.
     *
     * True, you might be tempted to define a "copy" constructor from
     * btree, like this:
     *
     *     stree(const btree&); 
     *
     * However, this is _not_ a good idea, since we can get this way
     * something which we call search tree but is not.  Indeed, nothing
     * guarantees that the binary tree we copy is a search tree.  True,
     * you can always use casting, but casting implies an extra mental
     * effort, which is often enough to prevent a mistake.
     */


    /*
     * member(s) returns some node from the current tree (the_tree)
     * having s as information (empty if there is no such node).
     */
    node* member(char*) const;

    /*
     * insert(s) inserts a new node holding s into the current tree.
     * The tree remains a search tree.
     */
    void insert(char*);

    /*
     * del(n) deletes node n from the current tree.  The tree remains a
     * search tree.
     */
    void del(node*);
};

#endif /* __STREE_H */
